unit AFQuickMail;

interface

uses
  Windows, Messages, SysUtils, Classes,Mapi, Forms, Dialogs, Controls,
  CommDlg;

type
  TAFQuickMail = class(TComponent)
  private
	 { Private declarations }
	 FTextToSend: TStrings;
	 fToEmail: String;
	 fToName: String;
	 fSubject: String;
	 fErrorMessage: String;
	 fFileName: TFileNAme;
	 function GetFileName: TFileName;
	 Procedure SetFileNAme(value: String);
	 procedure SetErrorMessage(value: String);
	 procedure SetTextToSend(Value: TStrings);
  protected
  	 function SendMail(const Subject, Body, FileName,
						SenderName, SenderEMail,
						RecipientName, RecipientEMail: string): Integer;
    { Protected declarations }
  public
	 { Public declarations }
	 constructor Create(AOwner: TComponent); override;
	 destructor Destroy; override;
	 function Execute: Boolean;
  published
	 { Published declarations }
	 property TextToSend: TStrings read fTextToSend write SetTextToSend;
	 property ToEmail: String read fToEmail write fToEmail;
	 property ToName: String read fToName write fToName;
	 property Subject: String read fSubject write fSubject;
	 property ErrorMessage: String read fErrorMessage write setErrorMessage;
	 property FileName: TFileNAme read getFileName write FFileName;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('AF', [TAFQuickMail]);
end;
constructor TAFQuickMail.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
   fTextToSend := TStringList.Create;
end;
destructor TAfQuickMail.Destroy;
begin
  fTextToSend.Free;
  inherited Destroy;
end;
function TAFQuickMail.SendMail(const Subject, Body, FileName,
						SenderName, SenderEMail,
						RecipientName, RecipientEMail: string): Integer;
var
  Message: TMapiMessage;
  lpSender, lpRecipient: TMapiRecipDesc;
  FileAttach: TMapiFileDesc;

  SM: TFNMapiSendMail;
  MAPIModule: HModule;
begin
  FillChar(Message, SizeOf(Message), 0);
  with Message do
  begin
	 if (Subject <> '') then
		lpszSubject := PChar(Subject);

	 if (Body <> '') then
		lpszNoteText := PChar(Body);

	 if (SenderEmail <> '') then
	 begin
		lpSender.ulRecipClass := MAPI_ORIG;
		if (SenderName = '') then
		  lpSender.lpszName := PChar(SenderEMail)
		else
		  lpSender.lpszName := PChar(SenderName);
		lpSender.lpszAddress := PChar('SMTP:' +SenderEmail);
		lpSender.ulReserved := 0;
		lpSender.ulEIDSize := 0;
		lpSender.lpEntryID := nil;
		lpOriginator := @lpSender;
	 end;

	 if (RecipientEmail <> '') then
	 begin
		lpRecipient.ulRecipClass := MAPI_TO;
		if (RecipientName = '') then
		  lpRecipient.lpszName := PChar(RecipientEMail)
		else
		  lpRecipient.lpszName := PChar(RecipientName);
		lpRecipient.lpszAddress := PChar(RecipientEmail);
		lpRecipient.ulReserved := 0;
		lpRecipient.ulEIDSize := 0;
		lpRecipient.lpEntryID := nil;
		nRecipCount := 1;
		lpRecips := @lpRecipient;
	 end
	 else
		lpRecips := nil;

	 if (FileName = '') then
	 begin
		nFileCount := 0;
		lpFiles := nil;
	 end
	 else
	 begin
		FillChar(FileAttach, SizeOf(FileAttach), 0);
		FileAttach.nPosition := Cardinal($FFFFFFFF);
		FileAttach.lpszPathName := PChar(FileName);

		nFileCount := 1;
		lpFiles := @FileAttach;
	 end;
  end;

  MAPIModule := LoadLibrary(PChar(MAPIDLL));
  if MAPIModule = 0 then
	 Result := -1
  else
	 try
		@SM := GetProcAddress(MAPIModule, 'MAPISendMail');
		if @SM <> nil then
		begin
		  Result := SM(0, Application.Handle, Message,0{MAPI_DIALOG or MAPI_LOGON_UI}, 0);
		end
		else
		  Result := 1;
	 finally
		FreeLibrary(MAPIModule);
	 end;

  
end;
procedure TAFQuickMail.SetErrorMessage(value: String);
const
	BaseError = 'Error sending mail';
begin
	if value = '' then
		value := BaseError;
	if fErrorMessage <> value then 
		FErrorMessage := value;
end;
Function TAFQuickMail.Execute: Boolean;
var
OutResult: Integer;
begin
	result := False;
	OutResult := SendMail(FSubject,fTextToSend.Text,FFileName,'','',fToName,fToEmail);
	if OutResult <> 0 then
		begin
			result := False;
			MessageDlg(fErrorMessage+' (' + IntToStr(OutResult) + ').', mtError,[mbOK], 0);
		end else result := True;
end;
procedure TAFQuickMail.SetTextToSend(Value: TStrings);
begin
	fTextToSend.Assign(value);
end;
function TAFQuickMail.GetFileName: tfilename;
begin
 Result := FFileName;
end;
procedure TAFQuickMail.SetFileNAme(Value: String);
begin
	if fFileName <> value then
	FFileName := Value;
end;
end.
 